Thalia_Container_Ubuntu/thalia/accession/urls.py
#-*- coding: utf-8 -*-
"""ThaliaDB is developed by the ABI-SOFT team of GQE-Le Moulon INRA unit
    
    Copyright (C) 2017, Guy-Ross Assoumou, Lan-Anh Nguyen, Olivier Akmansoy, Arthur Robieux, Alice Beaugrand, Yannick De-Oliveira, Delphine Steinbach

    This file is part of ThaliaDB

    ThaliaDB is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from django.conf.urls import url
from accession.views import accessionhome, accession_type, accessiondata

urlpatterns = [
                       url(r'^home/$', accessionhome, name='accessionhome'),                       
                       url(r'^types/$', accession_type, name='accessiontype'),
                       url(r'^accessiondata/(?P<type_id>\d+)/$', accessiondata, name='accessiondata')
                       ]

Thalia_Container_Ubuntu/thalia/urls.py
from django.conf.urls import include, url
# import notifications.urls
#from django.conf.urls import patterns, url, include
from django.contrib.auth.views import logout
from commonfct.genericviews import genericdelete, genericedit, getattributes, addattributes, typeedit, get_empty_file
from commonfct.filerenderer import filerenderer
from django.conf import settings
from django.conf.urls.static import static


from team.views import authentication, home, user_profile
# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()
print("reading urls")
urlpatterns = [
    # Examples:
    # url(r'^$', 'Thaliadbv3.views.home', name='home'),
    url(r'^home/$', home, name="home"),
    url(r'^userprofile/$', user_profile, name="user_profile"),
    #url(r'^team/', include('team.urls')),
    url(r'^$', authentication, name='login' ),
    url(r'^logout/$', logout, {'next_page': settings.ROOT_URL}, name='logout'),
    url(r'^contact/',include('team.urls')),
    url(r'^help/',include('team.urls')),
    url(r'^team/', include('team.urls')),
#     (r'^seedlot/', include('lot.urls')),
    url(r'^genealogy/', include('genealogy_managers.urls')),
    url(r'^lot/', include('lot.urls')),
    url(r'^phenotyping/', include('phenotyping.urls')),
    url(r'^accession/', include('accession.urls')),
    url(r'^images/', include('images.urls')),
    #Ajout Guy_Ross,
    url(r'^genotyping/', include('genotyping.urls')),
    url(r'^dataview/', include('dataview.urls')),
    url(r'^classification/', include('classification.urls')),
    
    #Appels JQuery
    url(r'^genericdelete/$', genericdelete, name='genericdelete' ),
    url(r'^genericedit/$', genericedit, name='genericedit' ),
    url(r'^getattributes/$', getattributes, name='getattributes' ),
    url(r'^addattributes/$', addattributes, name='addattributes' ),
    url(r'^entitytypeedit/$', typeedit, name='typeedit' ),
    
    url(r'^getemptyfile/(?P<classtype>[a-z]+)/(?P<object_id>[0-9]+)/$', get_empty_file, name='getemptyfile'),
    url(r'^filerenderer/(?P<filetype>\w+)/(?P<type_id>\d+)/$',filerenderer, name='filerenderer'),
    
    # Uncomment the admin/doc line below to enable admin documentation:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    # url(r'^admin/', include(admin.site.urls)),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

import os
import settings

Thalia_Container_Ubuntu/thalia/accession/models.py
# -*- coding: utf-8 -*-
"""LICENCE
    ThaliaDB is developed by the ABI-SOFT team of GQE-Le Moulon INRA unit
    
    Copyright (C) 2017, Guy-Ross Assoumou, Lan-Anh Nguyen, Olivier Akmansoy, Arthur Robieux, Alice Beaugrand, Yannick De-Oliveira, Delphine Steinbach

    This file is part of ThaliaDB

    ThaliaDB is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    LICENCE
"""

from jsonfield import JSONField

from django.db import models
from django.utils.encoding import force_bytes, force_text
from django.core.exceptions import ValidationError
from accession.managers import AccessionManager

from commonfct.constants import ATTRIBUTE_TYPES
from commonfct.managers import EntityTypeManager

# Create your models here.
class AccessionType(models.Model):
    """
      The AccessionType model gives information about the type of accessions.
      
      :var CharField name: name of the accession type
      :var TextField description: description of the accession type
    """
    
    name = models.CharField(max_length=100, unique=True)
    description = models.TextField(max_length=500, blank=True, null=True)
    def __str__(self):
        return self.name
    
    def attribute_set(self):
        return self.accessiontypeattribute_set

class Accession(models.Model):
    """
      The Accession model gives information about the accessions.
      
      :var ForeignKey type: type of the accession, defined in the AccessionType model
      :var CharField name: name of the accession
      :var CharField doi: doi of the accession
      :var BooleanField private_doi: check if the doi of the accession is a private doi or not
      :var TextField pedigree: pedigree of the accession
      :var BooleanField is_obsolete: check if the accession is obsolete or not
      :var TextField description: description of the accession
      :var JSONField attributes_values: dictionary containing the attributes values of the accession
      :var FloatField latitude: latitude of the accession
      :var FloatField longitude: longitude of the accession
      :var ManyToManyField projects: project(s) linked to the accession
    """
    
    type = models.ForeignKey('AccessionType', db_index=True)
    name = models.CharField(max_length=100, unique=True, db_index=True)
    doi = models.CharField(max_length=100, null=True, unique=True)
    private_doi= models.BooleanField(default=True)
    pedigree = models.TextField(max_length=500, blank=True, null=True)
    is_obsolete = models.BooleanField(default= False)
    description = models.TextField(max_length=500, blank=True, null=True)
    #variety = models.CharField(max_length=100, null=True)
    attributes_values = JSONField(blank=True, null=True)
    latitude = models.FloatField(blank=True, null=True)
    longitude = models.FloatField(blank=True, null=True)
    objects = AccessionManager() 
    
    #images = models.ManyToManyField('team.Documents', blank = True) 
    projects = models.ManyToManyField('team.Project', blank = True)
    
    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        if self.doi == "" :
            self.doi=None
        super(Accession, self).save(*args, **kwargs)
        
    def relation_set(self):
        return self.accessionrelation_set 
    
class AccessionTypeAttribute(models.Model):
    """
      The AccessionTypeAttribute model gives information about the attributes linked to the accession type
      
      :var CharField attribute_name: name of the attribute
      :var IntegerField type: type of the attribute
      :var ManyToManyField accession_type: accession type linked to the attribute, defined in the AccessionType model
    """
    attribute_name = models.CharField(max_length=100, blank=True)
    type = models.IntegerField(choices=ATTRIBUTE_TYPES, blank=True)
    accession_type = models.ManyToManyField('AccessionType', through='AccessionAttributePosition')

    objects = EntityTypeManager()
    
    def natural_key(self):
        return (self.attribute_name, self.type)

    def __str__(self):
        return self.attribute_name

    class Meta:
        unique_together = ("attribute_name","type")
    
    def clean(self):
        data = self.clean_fields()
     
    def save(self,*args, **kwargs):
        self.clean()
        super(AccessionTypeAttribute,self).save(*args, **kwargs)

class AccessionAttributePosition(models.Model):
    """
      The AccessionAttributePosition model gives information about the position of the attribute. 
      It allows the movement of the attribute thanks to a drag and drop system and the memorization of the position of this attribute.
      
      :var ForeignKey attribute: name of the attribute, defined with the AccessionTypeAttribute model
      :var ForeignKey type: type of the accession which is linked to the attribute, defined with the AccessionType model
      :var IntegerField position: integer rendering the position number
    """
    
    attribute = models.ForeignKey('AccessionTypeAttribute')
    type = models.ForeignKey('AccessionType')
    position = models.IntegerField()  
    
    class Meta:
        unique_together = ("type","position")        
        

Thalia_Container_Ubuntu/thalia/accession/forms.py
# -*- coding: utf-8 -*-
"""LICENCE
    ThaliaDB is developed by the ABI-SOFT team of GQE-Le Moulon INRA unit
    
    Copyright (C) 2017, Guy-Ross Assoumou, Lan-Anh Nguyen, Olivier Akmansoy, Arthur Robieux, Alice Beaugrand, Yannick De-Oliveira, Delphine Steinbach

    This file is part of ThaliaDB

    ThaliaDB is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    LICENCE
"""

from django import forms

from accession.models import AccessionType, AccessionTypeAttribute, Accession
from django.utils.safestring import mark_safe
from commonfct.forms_utils import HorizontalRadioSelect

requests=[('name','name'),
          ('project','project'),
          ('doi','doi')]
or_and_choices=[('and','and'),('or','or')]

class AccessionRefineSearchForm(forms.Form):
    """
      Form used for refined queries on the existing tables.
      
      :var ChoiceField or_and: Radio button allowing the choice between 'or' and 'and', which will be condition for the query
      :var ChoiceField request_by: menu containing the choices of columns on which the user can apply its query
      :var list requests: list of tuples that defines the fields on which the user can refine his search
      :var list or_and_choices: list of tuples that defines the choices between 'and' and 'or' conditions
    """
    or_and = forms.ChoiceField(widget=forms.RadioSelect(), choices=or_and_choices, required=True, initial="and")
    request_by = forms.ChoiceField(choices=requests)

class AccessionTypeForm(forms.ModelForm):
    """
      Form based on the AccessionType model managing data from this model
    """
    class Meta:
        model = AccessionType
        fields = '__all__'

class AccessionTypeAttForm(forms.ModelForm):
    """
      Form based on the AccessionTypeAttribute model managing data from this model
    """
    class Meta:
        model = AccessionTypeAttribute
        exclude = ['accession_type']
        #exclude = ['accession']#test guy
        widgets = {'attribute_name': forms.TextInput(attrs = {'id':'attributes_autocomplete'}),}
        

class AccessionDataForm(forms.ModelForm):  
    """
      Form based on the Accession model, allowing the creation of new accessions into the database
    """  
    class Meta:
        model = Accession
        exclude = ['attributes_values', 'type']
        

    def __init__(self, *args, **kwargs):
        if 'formstype' in kwargs.keys():
            attrs = kwargs['formstype']
            if 'data' in kwargs.keys():
                if 'instance' in kwargs.keys():
                    super(AccessionDataForm, self).__init__(data=kwargs['data'], instance=kwargs['instance'])
                else :
                    super(AccessionDataForm, self).__init__(data=kwargs['data'])
            else :
                super(AccessionDataForm, self).__init__()
            for at in attrs:
                self.fields[at.attribute_name.lower().replace(' ','_')] = forms.CharField(required = False)

        else :
            if 'data' in kwargs.keys():
                super(AccessionDataForm, self).__init__(data=kwargs['data'])
            else :
                super(AccessionDataForm, self).__init__()
        
        self.fields['doi'].required=False
    
    
SepChoices=[(',',' , '),
            (';',' ; ')]
class UploadFileForm(forms.Form):
    """
      Form allowing the uploading of a file, querying a delimiter to be readable
      
      :var FileField file: required field, file to be uploaded
      :var ChoiceField delimiter: delimiter of the file, required so that the developer knows how to read the file
      :var list SepChoices: list of tuples that defines the delimiters that can be used by the user
    """
    file = forms.FileField(required=True, label='Main files')
    delimiter = forms.CharField(label='Delimiter of the file ', initial=";")
    #delimiter = forms.ChoiceField(widget=HorizontalRadioSelect(), choices=SepChoices, required=True, initial=",")

Thalia_Container_Ubuntu/thalia/templates/accession/accession_base.html
{%extends "base.html"%}

{%block left_div%}
<div id="Menu">
   <div id="Menu_header">
     <div class="menu_header_left"> <span class="menu_text">ACCESSION MANAGEMENT</span> </div>
     <div class="menu_header_right"> </div>
   </div>
   <div id="Menu_content">
     	<a class="menu_item" href="{%url 'accessiontype'%}"><span>Accession Type</span></a><br/>
     <!--	<a class="menu_item" href="#"><span>Accession Image</span></a><br/> -->
   </div>
   <div id="Menu_header">
     <div class="menu_header_left"> <span class="menu_text">ACCESSION</span> </div>
     <div class="menu_header_right"> </div>
   </div>
   
   <div id="Menu_content">
   		{%for item in menu%}
   		<!-- <a class="menu_item" href="#"><span>{{item.name}}</span></a><br/> -->
   		<a class="menu_item" href="{%url 'accessiondata' item.id %}"><span>{{item.name}}</span></a><br/>
   		{%endfor%}
   </div>
   

   
   <!-- <div id="Menu_header">
     <div class="menu_header_left"> <span class="menu_text">GENEALOGY</span> </div>
     <div class="menu_header_right"> </div>
   </div>
   <div id="Menu_content">
   		<a class="menu_item" href="#"><span>Genealogy</span></a><br/>
     	<a class="menu_item" href="#"><span>Method</span></a><br/>
   </div> -->
</div>
{%endblock%}

Thalia_Container_Ubuntu/thalia/templates/accession/accession_data.html
{%extends "accession/accession_base.html"%}
{% load staticfiles %}

{%block moreheader%}
<link href='{%static "js/jquery-ui-1.11.2.custom/jquery-ui.css" %}' rel="stylesheet" type="text/css" />
<link rel="stylesheet" type="text/css" href='{%static "css/multi-select.css" %}'>

<script type="text/javascript" src='{%static "js/jquery-1.8.3.js" %}'></script>
<script type="text/javascript" src='{%static "js/jquery-ui-1.11.2.custom/jquery-ui.js" %}'></script>
<script type="text/javascript" src='{%static "js/basic_delete.js" %}'></script>
<script type="text/javascript" src='{%static "js/delete_checkbox.js" %}'></script>
<script type="text/javascript" src='{%static "js/basic_edit.js" %}'></script>
<script type="text/javascript" src='{%static "js/tablesorter/jquery.tablesorter.js" %}'></script>
<script type="text/javascript" src='{%static "js/widgets.js" %}'></script>
<script type="text/javascript" src='{%static "js/autocomplete.js" %}'></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.0.0/jquery.min.js"></script>
<!-- Bootstrap JavaScript -->
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-alpha/js/bootstrap.min.js"></script>
<script type="text/javascript" src='{%static "js/jquery.multi-select.js" %}'></script>

<script type="text/javascript" src='{%static "js/jquery.quicksearch.js" %}'></script>
<script type="text/javascript">
	$(document).ready(function () {
		$("#search_selected").quicksearch(".ms-selectable ul li", {
			noResults: '#noresults',
			stripeRows: ['odd', 'even'],
			loader: 'span.loading'
		});

		// $("#search_deselected").quicksearch(".ms-selection ul li", {
		// 	noResults: '#noresults',
		// 	stripeRows: ['odd', 'even'],
		// 	loader: 'span.loading'
		// });
	});


</script>
<!-- A mettre dans un fichier -->
<style>

.button {
  background-color: #f44336; /* Red */
  border: none;
  color: white;
  padding: 8px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 12px;
  margin: 4px 2px;
  cursor: pointer;
  border-radius: 3px;
}

</style>

{%endblock%}

{%block right_div%}
	<h1>{{title}}</h1><br /><br />
	
<!-- SIMPLE FORM -->
    {%include "common/simple_form.html" with form=form type=type %}

	<br>	 
<!-- SEARCH RESULT -->
	{% if search_result %}
	<br><b>YOUR SEARCH:</b><br>Condition: {{or_and}}<br>
		{% for i, j in search_result.items %}
			{% for data_type, data_text in j.items %}
				<br>{{data_type}} containing "{{data_text}}" 
			{% endfor %}	
		{% endfor %}
		{% if download_not_empty %}
			<br><br>
			<a href={%url 'return_csv' 'result_search' %}><input class='ui-button ui-widget ui-state-default ui-corner-all' value="Export search result" name="export_search_result"></input></a>
		{% endif %}
	{% endif %} </br>
		
<!-- SIMPLE TABLE -->
	{%if all%}
		{%include "common/simple_table.html" with all=all labels_genealogy=labels_genealogy names_genealogy=names_genealogy fields_label=fields_label nb_per_page=nb_per_page fields_name=fields_name app_label='accession' model_name='Accession' %}
	{%endif%}
	<script type="text/javascript">
		// run pre selected options
		$('#id_projects').multiSelect({
			selectableFooter: "<button class='button button1' id='select-all'>select all</button> <button class='button button2' id='deselect-all'>deselect all</button>",
			selectableHeader: "<input type='text' id='search_selected' class='search-input' autocomplete='off' placeholder='Search'>"
  			//selectionHeader: "<input type='text' id='search_deselected' class='search-input' autocomplete='off' placeholder='try \"4\"'>"
		});
		$('#select-all').click(function(){
		  $('#id_projects').multiSelect('select_all');
		  return false;
		});
		$('#deselect-all').click(function(){
		  $('#id_projects').multiSelect('deselect_all');
		  return false;
		});
	</script>
{%endblock%}

Thalia_Container_Ubuntu/thalia/templates/accession/accession_type.html
{%extends "accession/accession_base.html"%}
{% load staticfiles %}

{%block moreheader%}
<link href='{%static "js/jquery-ui-1.11.2.custom/jquery-ui.css" %}' rel="stylesheet" type="text/css" />
<script type="text/javascript" src='{%static "js/jquery-1.8.3.js" %}'></script>
<script type="text/javascript" src='{%static "js/jquery-ui-1.11.2.custom/jquery-ui.js" %}'></script>
<script type="text/javascript" src='{%static "js/basic_delete.js" %}'></script>
<script type="text/javascript" src='{%static "js/basic_edit.js" %}'></script>
<script type="text/javascript" src='{%static "js/tabs_type_edit.js" %}'></script>
<script type="text/javascript" src='{%static "js/delete_checkbox.js" %}'></script>
<script type="text/javascript" src='{%static "js/tablesorter/jquery.tablesorter.js" %}'></script> 
<script type="text/javascript" src='{%static "js/widgets.js" %}'></script>
<script type="text/javascript" src='{%static "js/autocomplete.js" %}'></script>
{%endblock%}

{%block right_div%}
	<h1>{{title}}</h1><br /><br />
    {%include "common/simple_type.html" with form=form attributes=attributes %}
	{% if error_field %}
		<div style="color:red;">{{error_field}}</div>
	{%endif %}
	{%if all%}
		{%include "common/simple_table.html" with all=all fields_label=fields_label fields_name=fields_name %}
	{%endif%}
	

{%endblock%}